#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>

#define WINDOWSIZE 100

#define DA 0.03125
float DI= 0.125;
float S=0.005;

struct PointRec{
	GLfloat cA;
	GLfloat cI;
	int allowChange;
};
typedef struct PointRec Point;


GLfloat BETA[WINDOWSIZE][WINDOWSIZE];
/*
GLfloat cA[WINDOWSIZE][WINDOWSIZE];
GLfloat cI[WINDOWSIZE][WINDOWSIZE];
GLfloat oldCA[WINDOWSIZE][WINDOWSIZE];
GLfloat oldCI[WINDOWSIZE][WINDOWSIZE];
*/
Point current[WINDOWSIZE][WINDOWSIZE];
Point old[WINDOWSIZE][WINDOWSIZE];

GLfloat displayMatrix[WINDOWSIZE][WINDOWSIZE][3];

int count=0;

void save()
{
	int i,j;
	for (i=0;i<WINDOWSIZE;i++){
		for (j=0;j<WINDOWSIZE;j++){
			old[i][j].cA=current[i][j].cA;
			old[i][j].cI=current[i][j].cI;
			displayMatrix[i][j][0]=current[i][j].cA/6.0;
			displayMatrix[i][j][1]=current[i][j].cA/6.0;
			displayMatrix[i][j][2]=0.0;
			
		}
	}
}

void changeImage()
{
	
	int i,j;
	GLfloat I, A;
	for (i=1;i<WINDOWSIZE-1;i++){
		for (j=0;j<WINDOWSIZE;j++){
			//ignore any areas marked as used
			if (current[i][j].allowChange==0)
				continue;
			
			I=S*(16-old[i][j].cI*old[i][j].cA);
			//if (I<=0.0)
			//	I=0.0;
			A=S*(old[i][j].cI*old[i][j].cA-old[i][j].cA-BETA[i][j]);
			//if (A<=0.0)
			//	A=0.0;	
			
			
			current[i][j].cI+=I+DI*(old[i+1][j].cI+old[i-1][j].cI+old[i][j-1].cI+old[i][j+1].cI-4*old[i][j].cI);
			current[i][j].cA+=A+DA*(old[i+1][j].cA+old[i-1][j].cA+old[i][j-1].cA+old[i][j+1].cA-4*old[i][j].cA);
			//if (cA[i][j]>=4.0)
			//	cA[i][j]=4.0;
			if (current[i][j].cA<0.0)
				current[i][j].cA=0.0;
			//if (cI[i][j]>=4.0)
			//	cI[i][j]=4.0;
			//if (cI[i][j]<0.0)
			//	cI[i][j]=0.11;
		}
	}
	
}

void changePattern(){
	int i,j;
	for (i=1;i<WINDOWSIZE-1;i++){
		for (j=0;j<WINDOWSIZE;j++){
				if (current[i][j].cA>=0.0 && current[i][j].cA<=0.01){
					current[i][j].allowChange=0;
					current[i][j].cA=4.0;
					current[i][j].cI=4.0;
				}
		}
	}
	S=0.02;
	DI=0.225;
}

	
void myinit()
{

	int i,j;
	GLfloat color=0.0;
	glShadeModel(GL_FLAT);
		
	glClearColor(0.0,0.0,0.0,1.0); /* Black Background */
		
	for (i=0;i<WINDOWSIZE;i++)
	{		
		for (j=0;j<WINDOWSIZE;j++){
			color=4.0;//(4.0*rand()/(RAND_MAX+1.0)); //random no. between 0.0 and 1.0
			current[i][j].cA=color;
			color=4.0;//(4.0*rand()/(RAND_MAX+1.0)); //random no. between 0.0 and 1.0
			current[i][j].cI=color;
			color=(0.1*rand()/(RAND_MAX+1.0))+11.95; //random no. between 11.5 and 12.5
			BETA[i][j]=color;
			current[i][j].allowChange=1;
		}
	
	}
	//changePattern();
	glPixelStorei(GL_UNPACK_ALIGNMENT,1);
	save(); //save concentrations
}

static int timer=0;
void display()
{
	glClear(GL_COLOR_BUFFER_BIT);
	glRasterPos2i(-1,-1);
	changeImage();
	save();
	glDrawPixels(WINDOWSIZE,WINDOWSIZE, GL_RGB,GL_FLOAT,displayMatrix);		
	if (timer%100 == 0) printf("%d\n",timer);		
	if (timer==20000) changePattern();	
	timer++;
	glFlush();
}	
void idle(){
	display(); 
}
int main(int argc, char ** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
	glutInitWindowSize(WINDOWSIZE,WINDOWSIZE);
	glutInitWindowPosition(0,0);
	glutCreateWindow("Testing Draw Pixel");
	glutDisplayFunc(display);
	glutIdleFunc(idle);
	myinit();
	glutMainLoop();
}
